function love.load()
  tick = require "tick"
  Object = require "classic"
  cron = require "cron"
  require "colors"
  require "minion"
  
  window_width, window_height = love.graphics.getDimensions()
  
  number = 0
  
  mouse = {}
  mouse.x = window_width/2
  mouse.y = window_height/2
  mouse.radius = 15

  user  = {}
  user.x = window_width * 0.1
  user.y = window_height/2
  user.radius = 12
  user.speed = 500
  user.color = {254,75,3} --extra_color.bloodOrange
  user.maxHealth = 1000
  user.currentHealth = user.maxHealth
  
  listOfMinions = {}
  listOfCasts = {}
  
  --dmg = 100
  
  m1 = Minion(window_width * 0.9, window_height/2, 12, 100, 10, 120)
  -- x, y, radius, currentHealth, dmg, range
  --make range number larger than radius for ranged minion
  
end


function distance(y1, y2, x1, x2)
  d = math.sqrt((x2 - x1) ^ 2 + (y2 - y1) ^ 2)
  return d
end  

function angle2points(y2, y1, x2, x1)
  angle2point = math.atan2(y2 - y1 , x2 - x1)
  return angle2point
end

function dmgResolution(dmg)
  user.currentHealth = user.currentHealth - dmg
end


function love.mousepressed(x, y, button)
  if button == 2 then
    mouse.x, mouse.y = x, y
  end
end

function love.keypressed (key, scancode) 
  if key == "space" then
    table.insert(listOfMinions, m1) 
  end
end


function love.update(dt)
  
  --user to mouse stuff
  --user2mouse = math.atan2(mouse.y - user.y , mouse.x - user.x)
  user2mouse = angle2points(mouse.y, user.y , mouse.x, user.x) 

  if user.x ~= mouse.x and user.y ~= mouse.y then
    user.x = user.x + (math.cos(user2mouse) * user.speed * dt) 
    user.y = user.y + (math.sin(user2mouse) * user.speed * dt)
    
    user.x = math.floor(user.x)
    user.y = math.floor(user.y)
    
  end


  
  for i,v in ipairs(listOfMinions) do
    v:update(dt)
    
    --remove dead
    if v.currentHealth < 0 then
      table.remove(listOfMinions, i)
    end
  end
  
  for i,v in ipairs(listOfCasts) do
    v:update(dt)
    
    if distance(v.y, user.y, v.x, user.x) < user.radius then 
      table.remove(listOfCasts, i)
    end
  end

end


function love.draw()
  
  love.graphics.setColor(love.math.colorFromBytes(basic_color.blue))
  --love.graphics.circle("fill", mouse.x, mouse.y, mouse.radius)
  
  
  love.graphics.setColor(love.math.colorFromBytes(user.color))
  if user.currentHealth > 0 then
    love.graphics.circle("fill", user.x, user.y, user.radius)
  end
  
  
  love.graphics.print( user.currentHealth, 20, 40)

  
  for i,v in ipairs(listOfMinions) do
    v:draw()
  end
  
  for i,v in ipairs(listOfCasts) do
    v:draw()
  end
end

